ramkomd {r d|d! L{nge leve LysKOM!

Jag har tillsammans med Inge kommit p} ett s{tt att dels f} ner
v{ntetiden i samband med syncningar till <1 sekund, dels f} ner
storleken p} serverprocessen till mer rimliga niv}er. Denna l|sning
lider dock av det stora problemet att den kr{ver dubbelt s} mycket
diskutrymme som den egentligen beh|ver. Det g|r {ven ramkomd, s} det
{r ingen f|rs{mring i det avseendet. Dock {r detta bara en tempor{r
l|sning i v{ntan p} ldb.

Varf|r spara allt p} en g}ng? Varf|r inte spara en liten del av filen
i taget, och utf|ra n}gra atomiska anrop mellan varje liten
delsynkning? Ungef{r s} t{nkte jag n{r jag kom p} f|ljande schema f|r
hur man kan g|ra det hela b{ttre {n det {r nu.

Den databas som ligger p} fil {r en |gonblickbild (snapshot) av det
som finns i LysKOM. S} {r det i ramkomd; s} blir det i diskomd.
(B{ttre namn, n}gon? lyskomd tycker jag {r reserverat f|r den version
som har en riktig cache&ldb.) I ramkomd skrivs allt ut p} disk
samtidigt. I diskomd minns man bara vad som skall sparas, och sparar
bara en bit i taget.

I ramkomd finns allt inne i ram-minnet (i teorin. I praktiken {r det
mesta utswappat - n}got som m{rks varje g}ng det {r dags att synca!).
I diskomd ligger det mesta p} disk. I minnet finns dels det som har
anv{nts nyligen, dels det som {r {ndrat och {nnu ej syncat. Diskomd
har alltid minst en, ofta tv}, databasfiler |ppna:

	Fil A		Senaste kompletta fil.
	Fil B		Fil under uppbyggnad.

(Dessutom textmassefilen, precis som ramkomd nuf|rtiden.)

S} till detaljerna:

Det finns tre typer av objekt som ber|rs av den h{r {ndringen:
Text_stat, Person och Conference. Jag anv{nder Person som ett exempel
nedan.

I ram-cache.c finns en array 

	Person *pers_arr[ MAX_CONF ];

Den byts mot

	Cache_node *pers_arr[ MAX_CONF ];

typedef struct cache_node {
	Bool	exists;
	Bool	exists_b;
	Bool	dirty;		/* [r *ptr modifierad? */
	void   *snap_shot;
	void   *ptr;
	off_t   pos;
	off_t   pos_b;
	struct cache_node *lru_link;
	int	lock_cnt;
} Cache_node;



UPPSTART

N{r servern startas scannar den igenom datafilen (fil A) och fyller i
f{ltet exists till TRUE/FALSE och pos till att peka p} b|rjan av det
st{lle i filen d{r data ligger. \vriga f{lt s{tts till FALSE/NULL/0.



CACHE_GET_PERSON

N{r ovanliggande rutiner vill l{sa en person h{nder f|ljande:

!exists			Returnera NULL
ptr != NULL		L{gg noden f|rst i lru_link. Returnera ptr.
snap_shot != NULL	Kopiera snap_shot till ptr. L{gg noden f|rst i
			lru_link. Returnera ptr.
annars			L{s in fr}n fil A, s{tt ptr till den inl{sta
			structen, l{gg noden f|rst i lru_link,
			returnera ptr.


MARK_PERSON_AS_CHANGED

N{r n}got har {ndrats s{tts dirty-flaggan till TRUE.


CREATE_PERSON

S{tt exists=TRUE, dirty=TRUE, ptr och lru.


DELETE_PERSON

S{tt exists=FALSE. ptr=NULL. Troligtvis error om lock_cnt != 0.



THROW-OUT

F|r att inte diskomd ska bli f|r stor sl{ngs saker ut ur cachen.
Algoritm: tag f|rsta elementet i lru_list. Om dirty==FALSE och
ptr!=NULL och lock_cnt==0 s} frig|r ptr. Upprepa tills antalet noder
med ptr!=NULL och dirty==FALSE {r mindre {n antalet "rena" element man
vill ha inne i minnet. (Smutsiga element sl{ngs aldrig ut.)


LOCK_PERSON

\ka lock_cnt.


UNLOCK_PERSON

Minska lock_cnt.


PRE-SYNC

Utsparningen till fil sker i tre steg. F|rst sveper man |ver alla
Cache_noder. F|r alla som har dirty=TRUE g|r man f|ljande:

    if ( lock_cnt == 0 ) {
	snap_shot = ptr; (Pekartilldelning, ej kopiering av inneh}llet.) 
	ptr = NULL;
	Ta bort ptr ur lru-kedjan.
    } else {
	snap_shot = copy(ptr);
    }

    dirty = FALSE;

F|r _alla_ noder g|rs dessutom f|ljande:

   b_exists==exists;


SYNC

Steg tv} utf|rs en liten bit i taget. Till exempel s} skulle man kunna
spara en person efter varje atomiskt anrop, eller s}.

b_exists==FALSE?	   S{tt pos_b. Skriv "@\n" till fil B.
[r snap_shot != NULL?	   S{tt pos_b. Skriv ut inneh}llet i snap_shot 
			   till fil B.
dirty==FALSE && ptr!=NULL  Skriv ut inneh}llet i ptr till fil B.
annars:			   Kopiera fr}n fil A till fil B. (Eftersom man
			   vet b}de var blocket b|rjar och slutar kan man
			   kopiera blocket utan att bry sig om vad som
			   st}r i det -> v{ldigt lite CPU g}r }t).




POST-SYNC

N{r alla Person:er har hanterats som i SYNC ovan {r det dags f|r det
tredje steget. D} g}r man igenom alla Cache_node:er och g|r f|ljande:

	pos = pos_b;
	file_b = FALSE;
	free(snap_shot);
	snap_shot = NULL;

Fil B som man f|rut hade |ppen f|r skrivning |ppnar man i st{llet f|r
l{sning som fil A.




ANM[RKNINGAR

Inneh}llet i snap_shot {r alltid "smutsigt" j{mf|rt med inneh}llet i
fil A. Det som snap_shot pekar p} finns aldrig med i lru-kedjan.
