# This file is included by all Makefiles in the LysKOM hierarchy.
# It gives default values for all variables that is normally used. 
# TOPDIR and SCRIPTDIR must be set before this file is included.
# If any of the variables are defined in the environment, that value
# will override the value that is set here.
#
# ceder is guilty.
#

SHELL=/bin/sh
AWK = gawk
SED = /usr/bin/sed
CC = gcc -ansi
RM = /usr/gnu/bin/rm -vf

INCLUDEDIR	= $(TOPDIR)/include
LIBDIR		= $(TOPDIR)/lib
ANSIDIR		= $(INCLUDEDIR)/ansi

INCLUDES = -I$(ANSIDIR) -I$(INCLUDEDIR)
OPTIMIZE-FLAGS = -O
MISC-CFLAGS = -g -Wall
PIPE = -pipe

# -h flag makes NULL pointer references generate runtime errors
LDFLAGS = -h -L$(LIBDIR)

CFLAGS =  $(INCLUDES)  $(OPTIMIZE-FLAGS)  $(MISC-CFLAGS) $(PIPE) $(TARGET)

# LysKOM executables that the typical user don't use go here.
# (The server, dbck, et c)

LYSKOMSYSBIN = /usr/lyskom/bin

# User executables (such as lyskom, kompost et c)

LYSKOMUSRBIN = /usr/local/bin



GENERIC-CLEAN = *~ *.o lib*.a dependencies core TAGS temp-Makefile  \
	 temp-?-Makefile

# Too ugly... and it swells...
#
# EXPORTS = CC="${CC}" SHELL="${SHELL}" AWK="${AWK}" SED="${SED}" 	\
# 	RM="${RM}" INCLUDEDIR="${INCLUDEDIR}" LIBDIR="${LIBDIR}"	\
# 	ANSIDIR="${ANSIDIR}" INCLUDES="${INCLUDES}"			\
# 	OPTIMIZE-FLAGS="${OPTIMIZE-FLAGS}"				\
# 	MISC-CFLAGS="${MISC-CFLAGS}" PIPE="${PIPE}"			\
# 	LDFLAGS="${LDFLAGS}" CFLAGS="${CFLAGS}"				\
# 	LYSKOMSYSBIN="${LYSKOMSYSBIN}" LYSKOMUSRBIN="${LYSKOMUSRBIN}"	\
# 	TOPDIR="${TOPDIR}" SCRIPTDIR="${SCRIPTDIR}" AR="${AR}" 		\
# 	ARFLAGS="${ARFLAGS}" GENERIC-CLEAN="${GENERIC-CLEAN}"

EXPORTS =

# The Makefiles also dependes on the variables
# AR, ARFLAGS
# that are automatically set by GNU Make.
